#include <bits/stdc++.h>


using namespace std;

#define int long long


signed main()
{
    int n, k;
    cin >> n >> k;
    vector<int> d(k);
    for (int i=0; i<k; i++)
    {
        cin >> d[i];
        int rez=d[i];
        for(int j=1;j<d[i]; i++)
        {
            if (n%j==0)
            {
                rez=rez^j;
            }
        }
        cout << rez;
    }
}